require "player"


 objects = {}

  objects.width = 50
  objects.height = 50
  objects.yvel = 1
  objects.maxLimit = 2
  objects.col = false
  objects.count = 0
  objects.speed = 0.2
  
  local  ranX = 1
  local ranY = 1
  local counter = 0

  
function spawnObjects(x, y, width, height, yvel, gravity)

   ranX = math.random(1, 400)

    local newObject = {
        x = x,
        y = y,
        width = width,
        height = height,
        yvel = yvel,
        gravity = gravity,
        }
       
  table.insert(objects,newObject)
  objects.count = #objects
  return newObject
  
 end

function OBJECT_UPDATE(dt)
 
 
  counter = counter + dt
  if counter > 1 then
  spawnObjects(ranX, 0, objects.width, objects.height, 1, world.gravity)
  counter = 0
end
 
 
  --UPDATES everything in the table "Objects"
  for i, object in ipairs(objects) do
         if object.yvel ~= 0 then
          object.yvel = object.yvel + object.gravity
         end
     if object.y + object.height < world.floorY  then
         object.y = object.y + object.yvel
       end
     
     if object.y >= world.floorY then
       object.yvel = 0
      -- object.y = world.floorY - object.height
      end   
  object.y = object.y + objects.speed
    end
    
   --Object collision 
     for i, object in ipairs(objects) do
     for i = 1, #objects do
      local o1 = objects[i]
     for j = i + 1, #objects do
      local o2 = objects[j]
        if o2.y + o2.height > o1.y and o2.x + o2.width> o1.x and o2.x < o1.x+o1.width and o2.y + o2.height < o1.y + o1.height then
          o2.yvel = 0

        end
     end
     end
   end
   


 for i, object in ipairs(objects) do
     player.fall = true
     player.yvel = player.yvel + 0.00000000001
 
     for j = 1, #objects do 
      local o = objects[j]
      if player.yvel >= -1 then
        if player.y + player.height >= o.y and player.x + player.width >= o.x and player.x <= o.x + o.width and player.y < o.y + o.height  then
        --  player.y = o.y - player.height
          player.fall = false
          player.yvel = 0
          
        if player.x + player.width >= o.x and player.y - player.width / 2 > o.y then
          player.moveR = false
        else player.moveR = true
          
          if player.x >= o.x + o.width then
          player.xvel = 0
        else player.moveL = true
          end
      end
      end
     end
   end
end
    
end
function OBJECT_DRAW()
  
  --DRAWING everything in the table "Objects"
  for i, object in ipairs(objects) do
         love.graphics.rectangle("fill", object.x, object.y, object.width, object.height)
         love.graphics.setColor(0,0,0,255)

         love.graphics.setColor(255,255,255,255)
        
    end

  
  end
